#define INCL_WIN
#define INCL_DOS
#include <os2.h>
#include <memory.h>
#include "wckey.h"

#pragma data_seg(SHAREDMEM)

static struct WCKEYINFO wckeyinfo = {0};
static HMODULE module;

#pragma data_seg()

BOOL EXPENTRY WinHookProc(HAB hab,PQMSG pqmsg,USHORT usRemove )
{
   if ( (pqmsg->msg == WM_CHAR) &&                    /* character message */
        !(SHORT1FROMMP(pqmsg->mp1) & KC_KEYUP) &&     /* key down */
        !WinIsChild(pqmsg->hwnd,wckeyinfo.hwndnbpage) && /* not in the hotkey settings */
        ( ((SHORT1FROMMP(pqmsg->mp1) & KC_CTRL) && wckeyinfo.ctrl) ||     /* CTRL state */
          ((SHORT1FROMMP(pqmsg->mp1) & KC_CTRL) == wckeyinfo.ctrl) ) &&
        ( ((SHORT1FROMMP(pqmsg->mp1) & KC_SHIFT) && wckeyinfo.shift) ||    /* SHIFT state */
          ((SHORT1FROMMP(pqmsg->mp1) & KC_SHIFT) == wckeyinfo.shift) ) &&
        ( ((SHORT1FROMMP(pqmsg->mp1) & KC_ALT) && wckeyinfo.alt) ||      /* ALT state */
          ((SHORT1FROMMP(pqmsg->mp1) & KC_ALT) == wckeyinfo.alt) ) &&
        ((SHORT1FROMMP(pqmsg->mp1) & KC_SCANCODE) && wckeyinfo.scancode && (CHAR4FROMMP(pqmsg->mp1) == wckeyinfo.scancode)) && /* the right key */
        wckeyinfo.hwnd  /* valid main warpcenter windowhandle */
      )
      {
         WinSetActiveWindow(HWND_DESKTOP,wckeyinfo.hwnd);
         WinPostMsg(wckeyinfo.hwnd, WM_BUTTON1DOWN, MPFROM2SHORT(1,1), 0);
         WinPostMsg(wckeyinfo.hwnd, WM_BUTTON1UP, MPFROM2SHORT(1,1), 0);
      }
   return(FALSE);
}

struct WCKEYINFO * EXPENTRY HookInit(void)
{
   /* setting hook */
   if(DosQueryModuleHandle("wckhook", &module))
      return FALSE;
   WinSetHook(WinQueryAnchorBlock(HWND_DESKTOP), NULLHANDLE, HK_INPUT, (PFN)WinHookProc, module);

   return(&wckeyinfo);
}

BOOL EXPENTRY HookKill(void)
{
   WinReleaseHook(WinQueryAnchorBlock(HWND_DESKTOP), NULLHANDLE, HK_INPUT, (PFN)WinHookProc, module);

   memset(&wckeyinfo,0,sizeof(wckeyinfo));

   return(TRUE);
}
